//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;
using Tecan.Sila2.ParameterDefaultsProvider.Tests;


namespace Tecan.Sila2.ParameterDefaultsProvider.Tests
{
    
    
    /// <summary>
    /// Data transfer object for the request of the File Example Method command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class FileExampleMethodRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _parameter;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public FileExampleMethodRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public FileExampleMethodRequestDto(string parameter, Tecan.Sila2.IBinaryStore store)
        {
            Parameter = new Tecan.Sila2.StringDto(parameter, store);
        }
        
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Parameter
        {
            get
            {
                return _parameter;
            }
            set
            {
                _parameter = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "tecan.sila.parameterdefaultsprovider/tests/ExampleFileConstraintProviderService/v" +
                    "1/Command/FileExampleMethod";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Parameter, "parameter");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Parameter, "parameter"));
        }
    }
}

